"use strict";
const mongodb_1 = require('mongodb');
class MongoConnector {
    constructor(url, started) {
        this.mongoUrl = url;
        if (started) {
            this.connect(started);
        }
    }
    connect(started) {
        const that = this;
        mongodb_1.MongoClient.connect(this.mongoUrl, function (err, db) {
            if (err) {
                return console.dir(err);
            }
            console.log('Connected to MongoDB at ' + that.mongoUrl);
            that.db = db;
            if (started) {
                started();
            }
        });
    }
    collection(name) {
        return this.db.collection(name);
    }
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = MongoConnector;
