import MongoConnector from './mongo_connector';
import * as Random from 'meteor-random';
import DataLoader = require('dataloader');
import { Collection, FindOneOptions, Cursor, ReplaceOneOptions, InsertOneWriteOpResult, UpdateWriteOpResult, DeleteWriteOpResultObject } from 'mongodb';
export default class MongoEntity<T> {
    connector: MongoConnector;
    random: typeof Random;
    private _collectionName;
    private _collection;
    private _singleLoader;
    private _multiLoader;
    private _dataLoaderOptions;
    static DataLoaderOptions: Object;
    readonly collection: Collection<T>;
    constructor(connector: MongoConnector, collectionName: string, cache?: any);
    clearUpdateCaches(selector: any): void;
    clearInsertCaches(selector: Object): void;
    assignFilter(object: Object, selector: Object, result: Object, include: 0 | 1): (k: string) => void;
    filter(object: Object, selector: Object): T;
    find(selector: Object, fields?: Object, skip?: number, limit?: number, timeout?: number): Cursor<T>;
    findOne(selector: Object, options?: FindOneOptions): Promise<T>;
    findOneCached(loader: DataLoader<string, T>, key: string, selector?: Object): Promise<T>;
    findOneCachedById(id: string, selector?: Object): Promise<T>;
    findManyCached(loader: DataLoader<string, T[]>, key: string, selector?: Object): Promise<T[]>;
    findAllCached(selector?: Object): Promise<T[]>;
    insert(document: T): Promise<InsertOneWriteOpResult>;
    insertMany(document: T[]): Promise<InsertOneWriteOpResult>;
    delete(selector: Object, many?: boolean): Promise<DeleteWriteOpResultObject>;
    update(selector: Object, update: Object, options?: ReplaceOneOptions): Promise<UpdateWriteOpResult>;
    createLoader(selectorFunction: (key: string) => Promise<any>, options: Object): DataLoader<string, any>;
}
